Bug 458187 - RFE: limiting Directory Manager (nsslapd-rootdn) bind access by source host (e.g. 127.0.0.1)
RFE: limiting Directory Manager (nsslapd-rootdn) bind access by source host (...
Status: CLOSED CURRENTRELEASE
Product: 389
Classification: Community
Component: Security - Access Control (ACL) (Show other bugs)
1.1.1
All Linux
high Severity high
: ---
: ---
Assigned To: Rich Megginson
Chandrasekar Kannan
https://www.redhat.com/archives/fedor...
:
Depends On:
Blocks: 389_1.3.0 512820 690319
  Show dependency treegraph
 
Reported: 2008-08-06 17:56 EDT by Aleksander Adamowski
Modified: 2015-01-04 18:33 EST (History)
7 users (show)

See Also:
Fixed In Version: 389-ds-base-1.2.11.5-1.fc17
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-03-04 18:31:00 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Aleksander Adamowski 2008-08-06 17:56:41 EDT
Description of problem:

The Directory Manager account (the one whose DN is specified in dse.ldif as nsslapd-rootdn) is a dangerously privileged account.

Access control does not apply to this user and compromising its DN and password gives full control over the directory server.

Therefore, it would be desirable to limit this user's bind access based on some additional criteria, in addition to the knowledge of the password.

Limits based on the source host (e.g. localhost) and/or time of day (e.g. only work hours) would be very useful. 

Currently an attacker can easily mount a brute force guessing attack on the Directory Manager account over the network and if he succeeds, he practically has full control over the directory server. The only defense against this is by using a very long manager password and hard to guess rootdn which may be somewhat unpractical.

This problem is especially significant for LDAP servers accessible from public networks.

Additional info:

Note that in OpenLDAP this is possible using the following ACL:

access to dn.base="cn=Manager,o=Example"
 by peername.regex=127\.0\.0\.1 auth
 by users none
 by anonymous none


This ACL however requires creating a concrete LDAP entry that corresponds to rootdn, setting a userPassword in taht entry, and leaving the rootpw in OpenLDAP configuration undefined. This way the concrete userPassword is used when binding and is subject to that ACL which only allows access from connections that origin from 127.0.0.1.

More details:
http://www.openldap.org/faq/data/cache/761.html
http://www.openldap.org/lists/openldap-software/200711/msg00342.html
Comment 2 Iain Morgan 2011-12-07 15:37:57 EST
Note that this issue is also relevant to replication manager DNs.

In some cases, it might also be desirable to limit binds to the root DN based on connect type. For example, limit the binds to LDAPI connections.
Comment 3 Martin Kosek 2012-01-04 08:43:21 EST
Upstream ticket:
https://fedorahosted.org/389/ticket/110
Comment 6 Nathan Kinder 2013-03-04 18:31:00 EST
This was fixed in 389-ds-base-1.2.11.5-1.fc17.  Closing.

Note You need to log in before you can comment on or make changes to this bug.